/*
	File:		CMComponent.h

	Contains:	Headers for CMM components

	Written by:	Konstantin Othmer

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

*/


/************************************************************

Created: Saturday, November 14, 1992 at 6:00 PM
 CMComponent.h
 C Interface to the Macintosh Libraries


 Copyright Apple Computer, Inc. 1991 - 1992
 All rights reserved

************************************************************/


#ifndef __CMCOMPONENT__
#define __CMCOMPONENT__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#ifndef __COMPONENTS__
#include <Components.h>
#endif

#ifndef __CMAPPLICATION__
#include <CMApplication.h>
#endif


/*
** CMM Components
*/

#define 	CMInterfaceVersion			0

/* CMM Component function selectors */
#define	kCMInit							0
#define	kCMMatchColors					1
#define	kCMGamutTest					2
#define	kCMMatchPixMap					3
#define	kCMCheckPixMap					4
#define	kCMConcatenateProfiles			5


/*
** Profile Responder Components
*/

#define ProfileResponderInterfaceRev	0

/* ProfileResponder Component function selectors */
#define	kCMGetProfile					0
#define	kCMSetProfile					1
#define	kCMSetProfileDescription		2
#define	kCMGetIndexedProfile			3
#define	kCMDeleteDeviceProfile			4
#define	kProfileResponderMaxSelector	kCMDeleteDeviceProfile


typedef ComponentInstance ProfileResponder;


/*
** Required CMM Component routines
*/

pascal CMError CMInit( ComponentInstance CMSession, CMProfileHandle srcProfile,
			CMProfileHandle dstProfile )
	= ComponentCallNow( kCMInit, 0x0008 );

pascal CMError CMMatchColors( ComponentInstance CMSession, CMColorList myColors, long count )
	= ComponentCallNow( kCMMatchColors, 0x0008 );

pascal CMError CMCheckColors( ComponentInstance CMSession, CMColorList myColors, long count, CMGamutResult result )
	= ComponentCallNow( kCMGamutTest, 0x000C );

/*
** Optional CMM Component routines
*/

pascal CMError CMMatchPixMap( ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackProcPtr progressProc, long refCon )
	= ComponentCallNow( kCMMatchPixMap, 0x000c );

pascal CMError CMCheckPixMap( ComponentInstance CMSession, PixMap *myPixMap, PixMapCallBackProcPtr progressProc, BitMap *myBitMap, long refCon )
	= ComponentCallNow( kCMCheckPixMap, 0x0010 );

pascal CMError CMConcatenateProfiles( ComponentInstance CMSession, CMProfileHandle thru, CMProfileHandle dst, CMProfileHandle *newDst )
	= ComponentCallNow( kCMConcatenateProfiles, 0x000C );

/*
** ProfileResponder Component routines
*/

pascal CMError  CMGetProfile( ProfileResponder myProfileResponder, CMProfileHandle aProfile, CMProfileHandle *returnedProfile )
	= ComponentCallNow( kCMGetProfile, 8 );

pascal CMError CMSetProfile( ProfileResponder myProfileResponder, CMProfileHandle newProfile )
	= ComponentCallNow( kCMSetProfile, 4 );

pascal CMError CMSetProfileDescription( ProfileResponder myProfileResponder, long DeviceData, CMProfileHandle hProfile )
	= ComponentCallNow( kCMSetProfileDescription, 8 );

pascal CMError CMGetIndexedProfile( ProfileResponder myProfileResponder, CMProfileSearchRecordHandle search,
		CMProfileHandle *returnProfile, long *index )
	= ComponentCallNow( kCMGetIndexedProfile, 0x000C );

pascal CMError CMDeleteDeviceProfile( ProfileResponder myProfileResponder, CMProfileHandle deleteMe )
	= ComponentCallNow( kCMDeleteDeviceProfile, 4 );

#endif