/*
	File:		TestTool.h

	Contains:	Declaration of a TTestTool

	Copyright:	 1991-1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __TESTTOOL__
#define __TESTTOOL__

#ifndef __LIBRARYMANAGER__
#include <LibraryManager.h>
#endif

#define kTestToolPrefix		"appl:test$"

typedef int (*PrintfFunc)(const char *, char*);
 
/**********************************************************************
** CLASS TTestTool
***********************************************************************/

#define kTTestToolID kTestToolPrefix "TTestTool,1.1"

class TTestTool : public TDynamic
{
	public:
							TTestTool();
							TTestTool(TStandardPool* thePool);
		virtual				~TTestTool();

		virtual void		SetPrintf(PrintfFunc);
		virtual void		Printf(const char*, ...) const;
		virtual void		InitTest(Boolean verbose, Boolean debug, int argc, char** argv) = 0;		
		virtual void		RunTestIteration(Boolean verbose, Boolean debug)	= 0;
		virtual void		EndTest(Boolean verbose, Boolean debug)				= 0;

			void			SetPool(TStandardPool* thePool);
			TStandardPool* 	GetPool();
		
	private:
		PrintfFunc			fPrint;
		Ptr					fPrintWorld;
		TStandardPool* 		fPool;
};


/*	-----------------------------------------------------------------
	Inline functions for TTestTool
	----------------------------------------------------------------- */

	inline void TTestTool::SetPool(TStandardPool* thePool)
	{
		fPool = thePool;
	}
	
	inline TStandardPool* TTestTool::GetPool()
	{
		return fPool;
	}


#endif
