/*
	File:		ExampleClass.h

	Contains:	Declarations for the TExampleClass

	Copyright:	 1991-1993 by Apple Computer, Inc., all rights reserved.

*/


#ifndef __EXAMPLECLASS__
#define __EXAMPLECLASS__


// the functionset ID for the example library
#define kExampleFunctionSet "appl:exam$ExampleFSet,1.1"

#ifndef __LIBRARYMANAGER__
#include <LibraryManager.h>
#endif

#ifdef __cplusplus

#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

typedef unsigned long	ulong;
typedef char*			(*HelloCPtr)(ulong*);
typedef pascal Ptr		(*HelloPPtr)(ulong&);

/**********************************************************************
** class TExampleClass
***********************************************************************/

#define kTExampleClassID	"appl:exam$TExampleClass,1.1"

#ifdef __SC__
class TExampleClass : public TSCDynamic
#else
class TExampleClass : public TDynamic
#endif
{
	public:
								TExampleClass();
		virtual					~TExampleClass();
		
		// New Methods

		virtual char* 			GetObjectName() const;
		virtual void 			SetObjectName(char *theName);

		virtual	void			DoThisAndThat();
		virtual	void			DoThat();

		virtual void			SetGlobalInt(long theValue);
		virtual long			GetGlobalInt();

		// Public non-virtual function
		// Dynamically exported by using ExportFunction
		void					GetGlobalRef(long*&);

		// Public static function
		// Dynamically exported by the ExportFunction
		static Boolean			Test(ulong test);
		static Boolean			Test(char* test);
		
	private:		
		char *fName;
		
		// static gExampleClassCount counts the number of instances
		static long				gExampleClassCount;
};


char* Hello(ulong&);
char* Hello(ulong*);
extern "C" char* HelloC(ulong*);
ulong Goodbye();
#ifdef THINK_CPLUS
pascal Ptr HELLOPASCAL(ulong& theHelloTicks);
pascal ulong GOODBYEPASCAL();
#else
pascal Ptr HelloPascal(ulong& theHelloTicks);
pascal ulong GoodbyePascal();
#endif

#else

typedef void TExampleClass;

/* Inline message dispatching code */
#define JSRA1          0x4e91
#define dispatchMessage(routineID)		\
	{0x2057,0x2050,0x2268,(4*routineID),JSRA1}

void ExDestructor(TExampleClass* this) = dispatchMessage(1);
char* ExGetObjectName(TExampleClass* this) = dispatchMessage(9);
void ExSetObjectName(TExampleClass* this, char *theName) = dispatchMessage(10);
void ExDoThisAndThat(TExampleClass* this) = dispatchMessage(11);
void ExDoThat(TExampleClass* this) = dispatchMessage(12);
void ExSetGlobalInt(TExampleClass* this, long theValue) = dispatchMessage(13);
long ExGetGlobalInt(TExampleClass* this) = dispatchMessage(14);

char* Hello();

#endif
#endif
